#include "image.h"

ostream& operator<<(ostream &ostr, Color color) {

  ostr << color.color;
  return ostr;

}

ImageRow::ImageRow(int _w) {

  Allocate(_w);

}

void ImageRow::Allocate(int _w) {

  w = _w;
  colors = new Color[w];

}

ImageRow::~ImageRow() {

  delete colors;

}

Color& ImageRow::operator[](int i) {

  return colors[i];

}

ostream& operator<<(ostream& ostr, ImageRow &imageRow) {

  for (int i = 0; i < imageRow.w; i++) {
    ostr << imageRow[i];
  }

  return ostr;

}

Image::Image(int _w, int _h) : w(_w), h(_h) {

  rows = new ImageRow[h];
  for (int ri = 0; ri < h; ri++) {
    rows[ri].Allocate(w);
  }

}

void Image::Show() {

  Show(cerr);

}

void Image::Show(ostream &ostr) {

  for (int ri = 0; ri < h; ri++) {
    ostr << rows[ri] << endl;
  }

}

void Image::MakeChecker(int checkerSize, Color col0, Color col1) {

  for (int ri = 0; ri < h; ri++) {
    int checkerRowi = ri/checkerSize;
    for (int ci = 0; ci < w; ci++) {
      int checkerColumni = ci/checkerSize;
      Color colorToUse = col0;
      if ((checkerRowi+checkerColumni)%2)
        colorToUse = col1;
      rows[ri][ci] = colorToUse;
    }
  }

}