
#ifndef IMAGE_H_
#define IMAGE_H_
#include <iostream>
using namespace std;

class Color{

  char color;
public:
  Color(char _color) : color(_color) {};
  friend ostream& operator<<(ostream &ostr, Color col);
  friend istream& operator>>(istream &istr, Color& col);
  Color() : color(' ') {};
};

class ImageRow {

  Color *colors;
  int w;
public:
  ImageRow() : colors(0), w(0) {};
  ImageRow(int _w);
  void Allocate(int _w);
  ~ImageRow();
  Color& operator[](int i);
  friend ostream& operator<<(ostream &ostr, ImageRow &col);
};

class Image {

  int w, h;
  ImageRow *rows; // there are h rows, each w wide
public:
  ~Image();
  Image(int _w, int _h);
  void MakeChecker(int checkerSize, Color col0, Color col1);
  void Clear(Color bgColor);
  void Show();
  void Show(ostream &ostr);
  ImageRow& operator[](int ri);
  bool InsideFrame(int ri, int ci);
  void SetPixelIfInsideFrame(int ri, int ci, Color color);
};

#endif