
#ifndef IMAGE_H_
#define IMAGE_H_

#include <ostream.h>

class Color{

  char color;
public:
  Color(char _color) : color(_color) {};
  friend ostream& operator<<(ostream &ostr, Color col);
  Color() : color(' ') {};
};

class ImageRow {

  Color *colors;
  int w;
public:
  ImageRow() : colors(0), w(0) {};
  ImageRow(int _w);
  void Allocate(int _w);
  ~ImageRow();
  Color& operator[](int i);
  friend ostream& operator<<(ostream &ostr, ImageRow &col);
};

class Image {

  int w, h;
  ImageRow *rows; // there are h rows, each w wide
public:
  Image(int _w, int _h);
  void MakeChecker(int checkerSize, Color col0, Color col1);
  void Show();
  void Show(ostream &ostr);
};

#endif